Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmeso.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 2823)
@@ -6,4 +6,5 @@
    !! History :   1.0  !  2002     (O. Aumont) Original code
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Quota model for iron
    !!----------------------------------------------------------------------
 #if defined key_pisces
@@ -14,12 +15,12 @@
    !!   p4z_meso_init  :   Initialization of the parameters for mesozooplankton
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
-   USE prtctl_trc
-   USE p4zint
-   USE p4zsink
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE p4zint          !  interpolation and computation of various fields
+   USE p4zprod         !  production
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
 
    IMPLICIT NONE
@@ -30,18 +31,18 @@
 
    !! * Shared module variables
-   REAL(wp), PUBLIC ::   &
-      xprefc   = 1.0_wp     ,  &  !: 
-      xprefp   = 0.2_wp     ,  &  !:
-      xprefz   = 1.0_wp     ,  &  !:
-      xprefpoc = 0.0_wp     ,  &  !:
-      resrat2  = 0.005_wp   ,  &  !:
-      mzrat2   = 0.03_wp    ,  &  !:
-      grazrat2 = 0.7_wp     ,  &  !:
-      xkgraz2  = 20E-6_wp   ,  &  !:
-      unass2   = 0.3_wp     ,  &  !:
-      sigma2   = 0.6_wp     ,  &  !:
-      epsher2  = 0.33_wp    ,  &  !:   
-      grazflux = 5.E3_wp 
-
+   REAL(wp), PUBLIC ::  part2    = 0.5_wp     !: part of calcite not dissolved in mesozoo guts
+   REAL(wp), PUBLIC ::  xprefc   = 1.0_wp     !: mesozoo preference for POC 
+   REAL(wp), PUBLIC ::  xprefp   = 0.3_wp     !: mesozoo preference for nanophyto
+   REAL(wp), PUBLIC ::  xprefz   = 1.0_wp     !: mesozoo preference for diatoms
+   REAL(wp), PUBLIC ::  xprefpoc = 0.3_wp     !: mesozoo preference for POC 
+   REAL(wp), PUBLIC ::  xthresh2 = 2E-7_wp    !: feeding threshold for mesozooplankton 
+   REAL(wp), PUBLIC ::  resrat2  = 0.005_wp   !: exsudation rate of mesozooplankton
+   REAL(wp), PUBLIC ::  mzrat2   = 0.04_wp    !: microzooplankton mortality rate 
+   REAL(wp), PUBLIC ::  grazrat2 = 0.9_wp     !: maximal mesozoo grazing rate
+   REAL(wp), PUBLIC ::  xkgraz2  = 20E-6_wp   !: non assimilated fraction of P by mesozoo 
+   REAL(wp), PUBLIC ::  unass2   = 0.3_wp     !: Efficicency of mesozoo growth 
+   REAL(wp), PUBLIC ::  sigma2   = 0.6_wp     !: Fraction of mesozoo excretion as DOM 
+   REAL(wp), PUBLIC ::  epsher2  = 0.3_wp     !: half sturation constant for grazing 2
+   REAL(wp), PUBLIC ::  grazflux = 3.E3_wp    !: mesozoo flux feeding rate
 
    !!* Substitution
@@ -65,17 +66,17 @@
       INTEGER, INTENT(in) ::   kt, jnt ! ocean time step
       INTEGER  :: ji, jj, jk
-      REAL(wp) :: zcompadi, zcompaph, zcompapoc, zcompaz
-      REAL(wp) :: zfact, zcompam, zdenom, zgraze2, zstep
-      REAL(wp) :: zgrarem2, zgrafer2, zgrapoc2, zprcaca, zmortz2
+      REAL(wp) :: zcompadi, zcompaph, zcompapoc, zcompaz, zcompam
+      REAL(wp) :: zgraze2 , zdenom, zncratio
+      REAL(wp) :: zfact   , zstep, zfood, zfoodlim
+      REAL(wp) :: zepshert, zepsherv, zgrarsig, zgraztot, zgraztotf
+      REAL(wp) :: zgrarem2, zgrafer2, zgrapoc2, zprcaca, zmortz2, zgrasrat
 #if defined key_kriest
       REAL znumpoc
 #endif
-      REAL(wp) :: zrespz2,ztortz2,zgrazd,zgrazz,zgrazpof
-      REAL(wp) :: zgrazn,zgrazpoc,zgraznf,zgrazf
-      REAL(wp) :: zgrazfff,zgrazffe
+      REAL(wp) :: zrespz2, ztortz2, zgrazd, zgrazz, zgrazpof
+      REAL(wp) :: zgrazn, zgrazpoc, zgraznf, zgrazf
+      REAL(wp) :: zgrazfff, zgrazffe
       CHARACTER (len=25) :: charout
-#if defined key_diatrc && defined key_iomput
       REAL(wp) :: zrfact2
-#endif
 
       !!---------------------------------------------------------------------
@@ -84,53 +85,48 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-
-               zcompam = MAX( ( trn(ji,jj,jk,jpmes) - 1.e-9 ), 0.e0 )
+               zcompam   = MAX( ( trn(ji,jj,jk,jpmes) - 1.e-8 ), 0.e0 )
 # if defined key_degrad
-               zstep   = xstep * facvol(ji,jj,jk)
+               zstep     = xstep * facvol(ji,jj,jk)
 # else
-               zstep   = xstep
+               zstep     = xstep
 # endif
-               zfact   = zstep * tgfunc(ji,jj,jk) * zcompam
+               zfact     = zstep * tgfunc(ji,jj,jk) * zcompam
 
                !  Respiration rates of both zooplankton
                !  -------------------------------------
-               zrespz2  = resrat2 * zfact * ( 1. + 3. * nitrfac(ji,jj,jk) )        &
-                  &     * trn(ji,jj,jk,jpmes) / ( xkmort + trn(ji,jj,jk,jpmes) )
+               zrespz2   = resrat2 * zfact * trn(ji,jj,jk,jpmes) / ( xkmort + trn(ji,jj,jk,jpmes) )  &
+                  &      + resrat2 * zfact * 3. * nitrfac(ji,jj,jk)
 
                !  Zooplankton mortality. A square function has been selected with
                !  no real reason except that it seems to be more stable and may mimic predation
                !  ---------------------------------------------------------------
-               ztortz2 = mzrat2 * 1.e6 * zfact * trn(ji,jj,jk,jpmes)
+               ztortz2   = mzrat2 * 1.e6 * zfact * trn(ji,jj,jk,jpmes)
                !
 
                zcompadi  = MAX( ( trn(ji,jj,jk,jpdia) - 1.e-8 ), 0.e0 )
                zcompaz   = MAX( ( trn(ji,jj,jk,jpzoo) - 1.e-8 ), 0.e0 )
-               zcompaph  = MAX( ( trn(ji,jj,jk,jpphy) - 2.e-7 ), 0.e0 )
+               zcompaph  = MAX( ( trn(ji,jj,jk,jpphy) - 1.e-8 ), 0.e0 )
                zcompapoc = MAX( ( trn(ji,jj,jk,jppoc) - 1.e-8 ), 0.e0 )
 
-               !  Microzooplankton grazing
-               !     ------------------------
-               zdenom = 1. / (  xkgraz2 + xprefc   * trn(ji,jj,jk,jpdia)   &
-                  &                     + xprefz   * trn(ji,jj,jk,jpzoo)   &
-                  &                     + xprefp   * trn(ji,jj,jk,jpphy)   &
-                  &                     + xprefpoc * trn(ji,jj,jk,jppoc)  )
-
-               zgraze2 = grazrat2 * zstep * Tgfunc2(ji,jj,jk) * zdenom * trn(ji,jj,jk,jpmes) 
-
-               zgrazd   = zgraze2  * xprefc   * zcompadi
-               zgrazz   = zgraze2  * xprefz   * zcompaz
-               zgrazn   = zgraze2  * xprefp   * zcompaph
-               zgrazpoc = zgraze2  * xprefpoc * zcompapoc
-
-               zgraznf  = zgrazn   * trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)
-               zgrazf   = zgrazd   * trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)
-               zgrazpof = zgrazpoc * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
-               
+               zfood     = xprefc * zcompadi + xprefz * zcompaz + xprefp * zcompaph + xprefpoc * zcompapoc + rtrn
+               zfoodlim  = MAX( 0., zfood - xthresh2 )
+               zdenom    = zfoodlim / zfood / (xkgraz2 + zfoodlim)
+
+               zgraze2   = grazrat2 * zstep * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jpmes) * zdenom
+               zgrazd    = zgraze2  * xprefc   * zcompadi
+               zgrazz    = zgraze2  * xprefz   * zcompaz
+               zgrazn    = zgraze2  * xprefp   * zcompaph
+               zgrazpoc  = zgraze2  * xprefpoc * zcompapoc
+
+               zgraznf   = zgrazn   * trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)
+               zgrazf    = zgrazd   * trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)
+               zgrazpof  = zgrazpoc * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
+
                !  Mesozooplankton flux feeding on GOC
                !  ----------------------------------
 # if ! defined key_kriest
-               zgrazffe = grazflux * zstep * wsbio4(ji,jj,jk)          &
-                  &                 * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jpgoc) * trn(ji,jj,jk,jpmes)
-               zgrazfff = zgrazffe * trn(ji,jj,jk,jpbfe) / (trn(ji,jj,jk,jpgoc) + rtrn)
+               zgrazffe  = grazflux * zstep * wsbio4(ji,jj,jk)          &
+                 &                 * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jpgoc) * trn(ji,jj,jk,jpmes)
+               zgrazfff  = zgrazffe * trn(ji,jj,jk,jpbfe) / (trn(ji,jj,jk,jpgoc) + rtrn)
 # else
                !!--------------------------- KRIEST3 -------------------------------------------
@@ -143,50 +139,47 @@
                !!--------------------------- KRIEST3 -------------------------------------------
 
-              zgrazffe = grazflux * zstep * wsbio3(ji,jj,jk)     &
+              zgrazffe   = grazflux * zstep * wsbio3(ji,jj,jk)     &
                   &                * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpmes)
-              zgrazfff = zgrazffe * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
+              zgrazfff   = zgrazffe * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
 # endif
-      
+              !
+              zgraztot   = zgrazd + zgrazz + zgrazn + zgrazpoc + zgrazffe
+              zgraztotf  = zgrazf + zgraznf + zgrazz * ferat3 + zgrazpof + zgrazfff 
 #if defined key_diatrc
               ! Total grazing ( grazing by microzoo is already computed in p4zmicro ) 
-              grazing(ji,jj,jk) = grazing(ji,jj,jk) + (  zgrazd + zgrazz + zgrazn + zgrazpoc + zgrazffe )
-#endif
-
+              grazing(ji,jj,jk) = grazing(ji,jj,jk) + zgraztot
+#endif
               !    Mesozooplankton efficiency
               !    --------------------------
-              zgrarem2 = ( zgrazd + zgrazz + zgrazn + zgrazpoc + zgrazffe ) * ( 1. - epsher2 - unass2 )
-#if ! defined key_kriest
-              zgrafer2 = ( zgrazf + zgraznf + zgrazz * ferat3 + zgrazpof + zgrazfff ) * ( 1.- epsher2 - unass2 ) & 
-                  &     + epsher2 * ( zgrazd   * MAX((trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)-ferat3),0.) &
-                  &                 + zgrazn   * MAX((trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)-ferat3),0.) &
-                  &                 + zgrazpoc * MAX((trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)-ferat3),0.) &
-                  &                 + zgrazffe * MAX((trn(ji,jj,jk,jpbfe) / (trn(ji,jj,jk,jpgoc) + rtrn)-ferat3),0.)  )
+              zgrasrat   =  zgraztotf / ( zgraztot + rtrn )
+              zncratio   = (  xprefc   * zcompadi * quotad(ji,jj,jk)  &
+                  &         + xprefp   * zcompaph * quotan(ji,jj,jk)  &
+                  &         + xprefz   * zcompaz                      &
+                  &         + xprefpoc * zcompapoc   ) / zfood 
+               zepshert  = epsher2 * MIN( 1., zncratio )
+               zepsherv  = zepshert * MIN( 1., zgrasrat / ferat3 )
+               zgrarem2  = zgraztot * ( 1. - zepsherv - unass2 )
+               zgrafer2  = zgraztot * MAX( 0. , ( 1. - unass2 ) * zgrasrat - ferat3 * zepshert ) 
+               zgrapoc2  = zgraztot * unass2
+
+               !   Update the arrays TRA which contain the biological sources and sinks
+               zgrarsig  = zgrarem2 * sigma2
+               tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) + zgrarsig
+               tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) + zgrarsig
+               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zgrarem2 - zgrarsig
+               tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2ut * zgrarsig
+               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zgrafer2
+               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) + zgrarsig
+               tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) + rno3 * zgrarsig              
+#if defined key_kriest
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zgrapoc2
+               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) + zgrapoc2 * xkr_dmeso
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zgraztotf * unass2
 #else
-              zgrafer2 = ( zgrazf + zgraznf + zgrazz * ferat3 + zgrazpof + zgrazfff ) * ( 1. - epsher2 - unass2 ) &
-                  &    + epsher2 * ( zgrazd   * MAX((trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)-ferat3),0.) &
-                  &                + zgrazn   * MAX((trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)-ferat3),0.) &
-                  &                + zgrazpoc * MAX((trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)-ferat3),0.) &
-                  &                + zgrazffe * MAX((trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)-ferat3),0.)  )
-
-#endif
-               !   Update the arrays TRA which contain the biological sources and sinks
-
-               zgrapoc2 =  zgrazd + zgrazz  + zgrazn + zgrazpoc + zgrazffe
-
-               tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) + zgrarem2 * sigma2
-               tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) + zgrarem2 * sigma2
-               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zgrarem2 * ( 1. - sigma2 )
-               tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2ut * zgrarem2 * sigma2
-               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zgrafer2
-               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) + zgrarem2 * sigma2
-               
-#if defined key_kriest
-               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zgrapoc2 * unass2
-               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) + zgrapoc2 * unass2 * xkr_dmeso
-#else
-               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zgrapoc2 * unass2
+               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zgrapoc2
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zgraztotf * unass2
 #endif
                zmortz2 = ztortz2 + zrespz2
-               tra(ji,jj,jk,jpmes) = tra(ji,jj,jk,jpmes) - zmortz2 + epsher2 * zgrapoc2
+               tra(ji,jj,jk,jpmes) = tra(ji,jj,jk,jpmes) - zmortz2 + zepsherv * zgraztot 
                tra(ji,jj,jk,jpdia) = tra(ji,jj,jk,jpdia) - zgrazd
                tra(ji,jj,jk,jpzoo) = tra(ji,jj,jk,jpzoo) - zgrazz
@@ -199,9 +192,10 @@
                tra(ji,jj,jk,jpdfe) = tra(ji,jj,jk,jpdfe) - zgrazf
 
-               zprcaca = xfracal(ji,jj,jk) * unass2 * zgrazn
+               zprcaca = xfracal(ji,jj,jk) * zgrazn
+               ! calcite production
 #if defined key_diatrc
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
 #endif
-               zprcaca = part * zprcaca
+               zprcaca = part2 * zprcaca
                tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) - zprcaca
                tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - 2. * zprcaca
@@ -212,12 +206,10 @@
                tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) - zgrazpoc * znumpoc &
                   &    + zmortz2  * xkr_dmeso - zgrazffe * znumpoc * wsbio4(ji,jj,jk) / ( wsbio3(ji,jj,jk) + rtrn )
-               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + ferat3 * zmortz2 &
-               &       + unass2 * ( ferat3 * zgrazz + zgraznf + zgrazf + zgrazpof + zgrazfff ) - zgrazfff - zgrazpof
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + ferat3 * zmortz2 - zgrazfff - zgrazpof
 #else
                tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zgrazpoc
                tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zmortz2 - zgrazffe
                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zgrazpof
-               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + ferat3 * zmortz2 &
-               &       + unass2 * ( ferat3 * zgrazz + zgraznf + zgrazf + zgrazpof + zgrazfff ) - zgrazfff
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + ferat3 * zmortz2 - zgrazfff
 #endif
 
@@ -228,19 +220,16 @@
 #if defined key_diatrc && defined key_iomput
       zrfact2 = 1.e3 * rfact2r
-      ! Total grazing of phyto by zoo
-      grazing(:,:,:) = grazing(:,:,:) * zrfact2 * tmask(:,:,:)
-      ! Calcite production
-      prodcal(:,:,:) = prodcal(:,:,:) * zrfact2 * tmask(:,:,:)
-      IF( jnt == nrdttrc ) then 
+      grazing(:,:,:) = grazing(:,:,:) * zrfact2 * tmask(:,:,:)   ! Total grazing of phyto by zoo
+      prodcal(:,:,:) = prodcal(:,:,:) * zrfact2 * tmask(:,:,:)   ! Calcite production
+      IF( jnt == nrdttrc ) THEN
          CALL iom_put( "GRAZ" , grazing  )  ! Total grazing of phyto by zooplankton
          CALL iom_put( "PCAL" , prodcal  )  ! Calcite production
       ENDIF
 #endif
-
-       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
-         WRITE(charout, FMT="('meso')")
-         CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-       ENDIF
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+        WRITE(charout, FMT="('meso')")
+        CALL prt_ctl_trc_info(charout)
+        CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+      ENDIF
 
    END SUBROUTINE p4z_meso
@@ -260,9 +249,9 @@
       !!----------------------------------------------------------------------
 
-      NAMELIST/nampismes/ grazrat2,resrat2,mzrat2,xprefc, xprefp, &
-         &             xprefz, xprefpoc, xkgraz2, epsher2, sigma2, unass2, grazflux
-
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampismes )
+      NAMELIST/nampismes/ part2, grazrat2, resrat2, mzrat2, xprefc, xprefp, xprefz,   &
+         &                xprefpoc, xthresh2, xkgraz2, epsher2, sigma2, unass2, grazflux
+
+      REWIND( numnatp )                     ! read numnat
+      READ  ( numnatp, nampismes )
 
 
@@ -271,16 +260,18 @@
          WRITE(numout,*) ' Namelist parameters for mesozooplankton, nampismes'
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         WRITE(numout,*) '    zoo preference for phyto                  xprefc    =', xprefc
-         WRITE(numout,*) '    zoo preference for POC                    xprefp    =', xprefp
-         WRITE(numout,*) '    zoo preference for zoo                    xprefz    =', xprefz
-         WRITE(numout,*) '    zoo preference for poc                    xprefpoc  =', xprefpoc
-         WRITE(numout,*) '    exsudation rate of mesozooplankton        resrat2   =', resrat2
-         WRITE(numout,*) '    mesozooplankton mortality rate            mzrat2    =', mzrat2
-         WRITE(numout,*) '    maximal mesozoo grazing rate              grazrat2  =', grazrat2
-         WRITE(numout,*) '    mesozoo flux feeding rate                 grazflux  =', grazflux
-         WRITE(numout,*) '    non assimilated fraction of P by mesozoo  unass2    =', unass2
-         WRITE(numout,*) '    Efficicency of Mesozoo growth             epsher2   =', epsher2
-         WRITE(numout,*) '    Fraction of mesozoo excretion as DOM      sigma2    =', sigma2
-         WRITE(numout,*) '    half sturation constant for grazing 2     xkgraz2   =', xkgraz2
+         WRITE(numout,*) '    part of calcite not dissolved in mesozoo guts  part2     =', part2
+         WRITE(numout,*) '    mesozoo preference for phyto                   xprefc    =', xprefc
+         WRITE(numout,*) '    mesozoo preference for POC                     xprefp    =', xprefp
+         WRITE(numout,*) '    mesozoo preference for zoo                     xprefz    =', xprefz
+         WRITE(numout,*) '    mesozoo preference for poc                     xprefpoc  =', xprefpoc
+         WRITE(numout,*) '    feeding threshold for mesozooplankton          xthresh2  =', xthresh2
+         WRITE(numout,*) '    exsudation rate of mesozooplankton             resrat2   =', resrat2
+         WRITE(numout,*) '    mesozooplankton mortality rate                 mzrat2    =', mzrat2
+         WRITE(numout,*) '    maximal mesozoo grazing rate                   grazrat2  =', grazrat2
+         WRITE(numout,*) '    mesozoo flux feeding rate                      grazflux  =', grazflux
+         WRITE(numout,*) '    non assimilated fraction of P by mesozoo       unass2    =', unass2
+         WRITE(numout,*) '    Efficicency of Mesozoo growth                  epsher2   =', epsher2
+         WRITE(numout,*) '    Fraction of mesozoo excretion as DOM           sigma2    =', sigma2
+         WRITE(numout,*) '    half sturation constant for grazing 2          xkgraz2   =', xkgraz2
       ENDIF
 
